Index: LMDZ5/branches/testing/libf/phylmd/rrtm/surdi.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/surdi.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/surdi.F90	(revision 2641)
@@ -54,5 +54,5 @@
 USE YOERDI   , ONLY : RRAE     ,&
 ! & RCARDI   ,RCH4     ,RN2O     ,RO3      ,RCFC11   ,&
- & RCFC12, &   
+! & RCFC12, &   
  & REPCLC   ,REPH2O   ,RSUNDUR  ,&
  & RCCO2    ,RCCH4    ,RCN2O    ,RCCFC11  ,RCCFC12
@@ -61,4 +61,5 @@
 IMPLICIT NONE
 
+!MPL/IM 20160915 on prend GES de phylmd
 !#include "clesphys.h"
 REAL(KIND=JPRB) :: ZAIRMWG, ZC11MWG, ZC12MWG, ZCH4MWG, ZCO2MWG, ZN2OMWG, ZO3MWG
Index: LMDZ5/branches/testing/libf/phylmd/rrtm/swr.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/rrtm/swr.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/rrtm/swr.F90	(revision 2641)
@@ -192,5 +192,6 @@
     ZCLOUD(JL) = ZSS1(JL)
   ELSEIF (NOVLP == 2) THEN
-   stop 'provisoire pour verifier option novlp=1b'
+!IM150716  stop 'provisoire pour verifier option novlp=1b'
+   print*,'rrtm provisoire pour verifier option novlp=2 maximum'
 !* maximum
     ZCLOUD(JL) = MAX( ZSS1(JL) , ZCLOUD(JL) )
@@ -198,5 +199,6 @@
 !++MODIFCODE
   ELSEIF ((NOVLP == 3).OR.((NOVLP  >=  5).AND.(NOVLP /= 8))) THEN
-   stop 'provisoire pour verifier option novlp=1c'
+!IM150716  stop 'provisoire pour verifier option novlp=1c'
+    print*,'rrtm provisoire pour verifier option novlp=3 random'
 !--MODIFCODE
 !* random
Index: LMDZ5/branches/testing/libf/phylmd/tracinca_mod.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/tracinca_mod.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/tracinca_mod.F90	(revision 2641)
@@ -138,5 +138,5 @@
   
 #ifdef INCA
-    IF (config_inca == 'aero') THEN 
+    IF (config_inca == 'aero' .OR. config_inca == 'chem') THEN 
        zpmfu(:,:)=pmfu(:,:)       
     ELSE IF (config_inca == 'aeNP') THEN
@@ -150,5 +150,5 @@
          pphi,cell_area,nstep,rneb,t_seri, &      
          rh,tau_aero,piz_aero,cg_aero,   &
-         rfname,ccm,lafin, config_inca)
+         rfname,ccm,lafin)
 #endif
 
Index: LMDZ5/branches/testing/libf/phylmd/wake.F90
===================================================================
--- LMDZ5/branches/testing/libf/phylmd/wake.F90	(revision 2595)
+++ LMDZ5/branches/testing/libf/phylmd/wake.F90	(revision 2641)
@@ -2,12 +2,14 @@
 ! $Id$
 
-SUBROUTINE wake(p, ph, pi, dtime, sigd_con, &
+SUBROUTINE wake(p, ph, pi, dtime, &
                 te0, qe0, omgb, &
                 dtdwn, dqdwn, amdwn, amup, dta, dqa, &
-                wdtpbl, wdqpbl, udtpbl, udqpbl, &
-                deltatw, deltaqw, dth, hw, sigmaw, wape, fip, gfl, &
-                dtls, dqls, ktopw, omgbdth, dp_omgb, wdens, tu, qu, &
-                dtke, dqke, dtpbl, dqpbl, omg, dp_deltomg, spread, cstar, &
-                d_deltat_gw, d_deltatw2, d_deltaqw2)
+                sigd_con, &
+                deltatw, deltaqw, sigmaw, wdens, &                          ! state variables
+                dth, hw, wape, fip, gfl, &
+                dtls, dqls, ktopw, omgbdth, dp_omgb, tu, qu, &
+                dtke, dqke, omg, dp_deltomg, spread, cstar, &
+                d_deltat_gw, &
+                d_deltatw2, d_deltaqw2, d_sigmaw2, d_wdens2)                ! tendencies
 
 
@@ -33,8 +35,9 @@
   ! le declenchement de nouvelles colonnes convectives.
 
-  ! Variables d'etat : deltatw    : ecart de temperature wake-undisturbed
-  ! area
-  ! deltaqw    : ecart d'humidite wake-undisturbed area
-  ! sigmaw     : fraction d'aire occupee par la poche.
+  ! State variables : 
+  ! deltatw    : temperature difference between wake and off-wake regions
+  ! deltaqw    : specific humidity difference between wake and off-wake regions
+  ! sigmaw     : fractional area covered by wakes.
+  ! wdens      : number of wakes per unit area
 
   ! Variable de sortie :
@@ -53,5 +56,5 @@
   ! omg    : Delta_omg =vertical velocity diff. wake-undist. (Pa/s)
   ! dp_deltomg  : vertical gradient of omg (s-1)
-  ! spread  : spreading term in dt_wake and dq_wake
+  ! spread  : spreading term in d_t_wake and d_q_wake
   ! deltatw     : updated temperature difference (T_w-T_u).
   ! deltaqw     : updated humidity difference (q_w-q_u).
@@ -126,5 +129,4 @@
   REAL, DIMENSION (klon, klev),     INTENT(IN)          :: te0, qe0
   REAL, DIMENSION (klon, klev),     INTENT(IN)          :: dtdwn, dqdwn
-  REAL, DIMENSION (klon, klev),     INTENT(IN)          :: wdtpbl, wdqpbl, udtpbl, udqpbl ! UNUSED
   REAL, DIMENSION (klon, klev),     INTENT(IN)          :: amdwn, amup
   REAL, DIMENSION (klon, klev),     INTENT(IN)          :: dta, dqa
@@ -133,6 +135,8 @@
   !
   ! Input/Output
+  ! State variables
   REAL, DIMENSION (klon, klev),     INTENT(INOUT)       :: deltatw, deltaqw
   REAL, DIMENSION (klon),           INTENT(INOUT)       :: sigmaw
+  REAL, DIMENSION (klon),           INTENT(INOUT)       :: wdens
 
   ! Sorties
@@ -143,13 +147,13 @@
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dtls, dqls
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dtke, dqke
-  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dtpbl, dqpbl
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: spread
-  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltatw2, d_deltaqw2
   REAL, DIMENSION (klon, klev+1),   INTENT(OUT)         :: omgbdth, omg
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: dp_omgb, dp_deltomg
   REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltat_gw
   REAL, DIMENSION (klon),           INTENT(OUT)         :: hw, wape, fip, gfl, cstar
-  REAL, DIMENSION (klon),           INTENT(OUT)         :: wdens
   INTEGER, DIMENSION (klon),        INTENT(OUT)         :: ktopw
+  ! Tendencies of state variables
+  REAL, DIMENSION (klon, klev),     INTENT(OUT)         :: d_deltatw2, d_deltaqw2
+  REAL, DIMENSION (klon),           INTENT(OUT)         :: d_sigmaw2, d_wdens2
 
   ! Variables internes
@@ -157,94 +161,98 @@
 
   ! Variables à fixer
-  REAL alon
-  LOGICAL, SAVE :: first = .TRUE.
+  REAL                                                  :: alon
+  LOGICAL, SAVE                                         :: first = .TRUE.
   !$OMP THREADPRIVATE(first)
-  REAL, SAVE ::  stark, wdens_ref, coefgw, alpk, crep_upper, crep_sol  
+  REAL, SAVE                                            :: stark, wdens_ref, coefgw, alpk
+  REAL, SAVE                                            :: crep_upper, crep_sol  
   !$OMP THREADPRIVATE(stark, wdens_ref, coefgw, alpk, crep_upper, crep_sol)
 
-  REAL delta_t_min
-  INTEGER nsub
-  REAL dtimesub
-  REAL sigmad, hwmin, wapecut
-  REAL :: sigmaw_max
-  REAL :: dens_rate
-  REAL wdens0
+  REAL                                                  :: delta_t_min
+  INTEGER                                               :: nsub
+  REAL                                                  :: dtimesub
+  REAL                                                  :: sigmad, hwmin, wapecut
+  REAL                                                  :: sigmaw_max
+  REAL                                                  :: dens_rate
+  REAL                                                  :: wdens0
   ! IM 080208
-  LOGICAL, DIMENSION (klon) :: gwake
+  LOGICAL, DIMENSION (klon)                             :: gwake
 
   ! Variables de sauvegarde
-  REAL, DIMENSION (klon, klev) :: deltatw0
-  REAL, DIMENSION (klon, klev) :: deltaqw0
-  REAL, DIMENSION (klon, klev) :: te, qe
-  REAL, DIMENSION (klon) :: sigmaw0, sigmaw1
+  REAL, DIMENSION (klon, klev)                          :: deltatw0
+  REAL, DIMENSION (klon, klev)                          :: deltaqw0
+  REAL, DIMENSION (klon, klev)                          :: te, qe
+  REAL, DIMENSION (klon)                                :: sigmaw0, sigmaw1
 
   ! Variables pour les GW
-  REAL, DIMENSION (klon) :: ll
-  REAL, DIMENSION (klon, klev) :: n2
-  REAL, DIMENSION (klon, klev) :: cgw
-  REAL, DIMENSION (klon, klev) :: tgw
+  REAL, DIMENSION (klon)                                :: ll
+  REAL, DIMENSION (klon, klev)                          :: n2
+  REAL, DIMENSION (klon, klev)                          :: cgw
+  REAL, DIMENSION (klon, klev)                          :: tgw
 
   ! Variables liées au calcul de hw
-  REAL, DIMENSION (klon) :: ptop_provis, ptop, ptop_new
-  REAL, DIMENSION (klon) :: sum_dth
-  REAL, DIMENSION (klon) :: dthmin
-  REAL, DIMENSION (klon) :: z, dz, hw0
-  INTEGER, DIMENSION (klon) :: ktop, kupper
+  REAL, DIMENSION (klon)                                :: ptop_provis, ptop, ptop_new
+  REAL, DIMENSION (klon)                                :: sum_dth
+  REAL, DIMENSION (klon)                                :: dthmin
+  REAL, DIMENSION (klon)                                :: z, dz, hw0
+  INTEGER, DIMENSION (klon)                             :: ktop, kupper
 
   ! Sub-timestep tendencies and related variables
-  REAL d_deltatw(klon, klev), d_deltaqw(klon, klev)
-  REAL d_te(klon, klev), d_qe(klon, klev)
-  REAL d_sigmaw(klon), alpha(klon)
-  REAL q0_min(klon), q1_min(klon)
-  LOGICAL wk_adv(klon), ok_qx_qw(klon)
-  REAL epsilon
+  REAL, DIMENSION (klon, klev)                          :: d_deltatw, d_deltaqw
+  REAL, DIMENSION (klon, klev)                          :: d_te, d_qe
+  REAL, DIMENSION (klon)                                :: d_sigmaw, alpha
+  REAL, DIMENSION (klon)                                :: q0_min, q1_min
+  LOGICAL, DIMENSION (klon)                             :: wk_adv, ok_qx_qw
+  REAL, SAVE                                            :: epsilon
+  !$OMP THREADPRIVATE(epsilon)
   DATA epsilon/1.E-15/
 
   ! Autres variables internes
-  INTEGER isubstep, k, i
-
-  REAL, DIMENSION (klon) :: sum_thu, sum_tu, sum_qu, sum_thvu
-  REAL, DIMENSION (klon) :: sum_dq, sum_rho
-  REAL, DIMENSION (klon) :: sum_dtdwn, sum_dqdwn
-  REAL, DIMENSION (klon) :: av_thu, av_tu, av_qu, av_thvu
-  REAL, DIMENSION (klon) :: av_dth, av_dq, av_rho
-  REAL, DIMENSION (klon) :: av_dtdwn, av_dqdwn
-
-  REAL, DIMENSION (klon, klev) :: rho, rhow
-  REAL, DIMENSION (klon, klev+1) :: rhoh
-  REAL, DIMENSION (klon, klev) :: rhow_moyen
-  REAL, DIMENSION (klon, klev) :: zh
-  REAL, DIMENSION (klon, klev+1) :: zhh
-  REAL, DIMENSION (klon, klev) :: epaisseur1, epaisseur2
-
-  REAL, DIMENSION (klon, klev) :: the, thu
-
-  ! REAL, DIMENSION(klon,klev) :: d_deltatw, d_deltaqw
-
-  REAL, DIMENSION (klon, klev+1) :: omgbw
-  REAL, DIMENSION (klon) :: pupper
-  REAL, DIMENSION (klon) :: omgtop
-  REAL, DIMENSION (klon, klev) :: dp_omgbw
-  REAL, DIMENSION (klon) :: ztop, dztop
-  REAL, DIMENSION (klon, klev) :: alpha_up
-
-  REAL, DIMENSION (klon) :: rre1, rre2
-  REAL :: rrd1, rrd2
-  REAL, DIMENSION (klon, klev) :: th1, th2, q1, q2
-  REAL, DIMENSION (klon, klev) :: d_th1, d_th2, d_dth
-  REAL, DIMENSION (klon, klev) :: d_q1, d_q2, d_dq
-  REAL, DIMENSION (klon, klev) :: omgbdq
-
-  REAL, DIMENSION (klon) :: ff, gg
-  REAL, DIMENSION (klon) :: wape2, cstar2, heff
-
-  REAL, DIMENSION (klon, klev) :: crep
-
-  REAL, DIMENSION (klon, klev) :: ppi
+  INTEGER                                               ::isubstep, k, i
+
+  REAL                                                  :: sigmaw_targ
+
+  REAL, DIMENSION (klon)                                :: sum_thu, sum_tu, sum_qu, sum_thvu
+  REAL, DIMENSION (klon)                                :: sum_dq, sum_rho
+  REAL, DIMENSION (klon)                                :: sum_dtdwn, sum_dqdwn
+  REAL, DIMENSION (klon)                                :: av_thu, av_tu, av_qu, av_thvu
+  REAL, DIMENSION (klon)                                :: av_dth, av_dq, av_rho
+  REAL, DIMENSION (klon)                                :: av_dtdwn, av_dqdwn
+
+  REAL, DIMENSION (klon, klev)                          :: rho, rhow
+  REAL, DIMENSION (klon, klev+1)                        :: rhoh
+  REAL, DIMENSION (klon, klev)                          :: rhow_moyen
+  REAL, DIMENSION (klon, klev)                          :: zh
+  REAL, DIMENSION (klon, klev+1)                        :: zhh
+  REAL, DIMENSION (klon, klev)                          :: epaisseur1, epaisseur2
+
+  REAL, DIMENSION (klon, klev)                          :: the, thu
+
+  REAL, DIMENSION (klon, klev+1)                        :: omgbw
+  REAL, DIMENSION (klon)                                :: pupper
+  REAL, DIMENSION (klon)                                :: omgtop
+  REAL, DIMENSION (klon, klev)                          :: dp_omgbw
+  REAL, DIMENSION (klon)                                :: ztop, dztop
+  REAL, DIMENSION (klon, klev)                          :: alpha_up
+
+  REAL, DIMENSION (klon)                                :: rre1, rre2
+  REAL                                                  :: rrd1, rrd2
+  REAL, DIMENSION (klon, klev)                          :: th1, th2, q1, q2
+  REAL, DIMENSION (klon, klev)                          :: d_th1, d_th2, d_dth
+  REAL, DIMENSION (klon, klev)                          :: d_q1, d_q2, d_dq
+  REAL, DIMENSION (klon, klev)                          :: omgbdq
+
+  REAL, DIMENSION (klon)                                :: ff, gg
+  REAL, DIMENSION (klon)                                :: wape2, cstar2, heff
+                                                        
+  REAL, DIMENSION (klon, klev)                          :: crep
+                                                        
+  REAL, DIMENSION (klon, klev)                          :: ppi
 
   ! cc nrlmd
-  REAL, DIMENSION (klon) :: death_rate, nat_rate
-  REAL, DIMENSION (klon, klev) :: entr
-  REAL, DIMENSION (klon, klev) :: detr
+  REAL, DIMENSION (klon)                                :: death_rate, nat_rate
+  REAL, DIMENSION (klon, klev)                          :: entr
+  REAL, DIMENSION (klon, klev)                          :: detr
+
+  REAL, DIMENSION(klon)                                 :: sigmaw_in   ! pour les prints
 
   ! -------------------------------------------------------------------------
@@ -312,5 +320,5 @@
   ! Les densites peuvent evoluer si les poches debordent
   ! (voir au tout debut de la boucle sur les substeps)
-  wdens = wdens_ref
+  wdens(:) = wdens_ref
 
   ! print*,'stark',stark
@@ -347,4 +355,7 @@
     END DO
   END DO
+  DO i = 1, klon
+   sigmaw_in(i) = sigmaw(i)
+  END DO
   ! sigmaw1=sigmaw
   ! IF (sigd_con.GT.sigmaw1) THEN
@@ -353,10 +364,16 @@
   DO i = 1, klon
     ! c      sigmaw(i) = amax1(sigmaw(i),sigd_con(i))
-    sigmaw(i) = amax1(sigmaw(i), sigmad)
-    sigmaw(i) = amin1(sigmaw(i), 0.99)
+!jyg<
+!!    sigmaw(i) = amax1(sigmaw(i), sigmad)
+!!    sigmaw(i) = amin1(sigmaw(i), 0.99)
+    sigmaw_targ = min(max(sigmaw(i), sigmad),0.99)
+    d_sigmaw2(i) = sigmaw_targ - sigmaw(i)
+    sigmaw(i) = sigmaw_targ
+!>jyg
     sigmaw0(i) = sigmaw(i)
     wape(i) = 0.
     wape2(i) = 0.
     d_sigmaw(i) = 0.
+    d_wdens2(i) = 0.
     ktopw(i) = 0
   END DO
@@ -433,6 +450,6 @@
         n2(i, k) = 0
       ELSE
-        n2(i, k) = amax1(0., -rg**2/the(i,k)*rho(i,k)*(the(i,k+1)-the(i, &
-          k-1))/(p(i,k+1)-p(i,k-1)))
+        n2(i, k) = amax1(0., -rg**2/the(i,k)*rho(i,k)*(the(i,k+1)-the(i,k-1))/ &
+                             (p(i,k+1)-p(i,k-1)))
       END IF
       zh(i, k) = (zhh(i,k)+zhh(i,k+1))/2
@@ -504,6 +521,6 @@
       IF (dth(i,k)>-delta_t_min .AND. dth(i,k-1)<-delta_t_min .AND. &
           ptop_provis(i)==ph(i,1)) THEN
-        ptop_provis(i) = ((dth(i,k)+delta_t_min)*p(i,k-1)-(dth(i, &
-          k-1)+delta_t_min)*p(i,k))/(dth(i,k)-dth(i,k-1))
+        ptop_provis(i) = ((dth(i,k)+delta_t_min)*p(i,k-1)- &
+                          (dth(i,k-1)+delta_t_min)*p(i,k))/(dth(i,k)-dth(i,k-1))
       END IF
     END DO
@@ -602,4 +619,6 @@
         deltatw(i, k) = 0.
         deltaqw(i, k) = 0.
+        d_deltatw2(i,k) = -deltatw0(i,k)
+        d_deltaqw2(i,k) = -deltaqw0(i,k)
       END IF
     END DO
@@ -671,6 +690,7 @@
     av_dqdwn(i) = sum_dqdwn(i)/hw0(i)
 
-    wape(i) = -rg*hw0(i)*(av_dth(i)+epsim1*(av_thu(i)*av_dq(i)+av_dth(i)*av_qu(i &
-      )+av_dth(i)*av_dq(i)))/av_thvu(i)
+    wape(i) = -rg*hw0(i)*(av_dth(i)+ &
+        epsim1*(av_thu(i)*av_dq(i)+av_dth(i)*av_qu(i)+av_dth(i)*av_dq(i)))/av_thvu(i)
+
   END DO
 
@@ -686,4 +706,6 @@
         deltaqw(i, k) = 0.
         dth(i, k) = 0.
+        d_deltatw2(i,k) = -deltatw0(i,k)
+        d_deltaqw2(i,k) = -deltaqw0(i,k)
       END IF
     END DO
@@ -695,5 +717,10 @@
       cstar(i) = 0.
       hw(i) = hwmin
-      sigmaw(i) = amax1(sigmad, sigd_con(i))
+!jyg<
+!!      sigmaw(i) = amax1(sigmad, sigd_con(i))
+      sigmaw_targ = max(sigmad, sigd_con(i))
+      d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+      sigmaw(i) = sigmaw_targ
+!>jyg
       fip(i) = 0.
       gwake(i) = .FALSE.
@@ -708,11 +735,11 @@
   ! --------------------------
   DO i = 1, klon
-    q0_min(i) = min((qe(i,1)-sigmaw(i)*deltaqw(i,1)), (qe(i, &
-      1)+(1.-sigmaw(i))*deltaqw(i,1)))
+    q0_min(i) = min((qe(i,1)-sigmaw(i)*deltaqw(i,1)),  &
+                    (qe(i,1)+(1.-sigmaw(i))*deltaqw(i,1)))
   END DO
   DO k = 2, klev
     DO i = 1, klon
-      q1_min(i) = min((qe(i,k)-sigmaw(i)*deltaqw(i,k)), (qe(i, &
-        k)+(1.-sigmaw(i))*deltaqw(i,k)))
+      q1_min(i) = min((qe(i,k)-sigmaw(i)*deltaqw(i,k)), &
+                      (qe(i,k)+(1.-sigmaw(i))*deltaqw(i,k)))
       IF (q1_min(i)<=q0_min(i)) THEN
         q0_min(i) = q1_min(i)
@@ -752,7 +779,7 @@
       IF (wk_adv(i) .AND. cstar(i)>0.01) THEN
         omg(i, kupper(i)+1) = -rg*amdwn(i, kupper(i)+1)/sigmaw(i) + &
-          rg*amup(i, kupper(i)+1)/(1.-sigmaw(i))
-        wdens0 = (sigmaw(i)/(4.*3.14))*((1.-sigmaw(i))*omg(i,kupper(i)+1)/(( &
-          ph(i,1)-pupper(i))*cstar(i)))**(2)
+                               rg*amup(i, kupper(i)+1)/(1.-sigmaw(i))
+        wdens0 = (sigmaw(i)/(4.*3.14))* &
+          ((1.-sigmaw(i))*omg(i,kupper(i)+1)/((ph(i,1)-pupper(i))*cstar(i)))**(2)
         IF (wdens(i)<=wdens0*1.1) THEN
           wdens(i) = wdens0
@@ -770,7 +797,13 @@
       IF (wk_adv(i)) THEN
         gfl(i) = 2.*sqrt(3.14*wdens(i)*sigmaw(i))
-        sigmaw(i) = amin1(sigmaw(i), sigmaw_max)
-      END IF
-    END DO
+!jyg<
+!!        sigmaw(i) = amin1(sigmaw(i), sigmaw_max)
+        sigmaw_targ = min(sigmaw(i), sigmaw_max)
+        d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+        sigmaw(i) = sigmaw_targ
+!>jyg
+      END IF
+    END DO
+
     DO i = 1, klon
       IF (wk_adv(i)) THEN
@@ -783,4 +816,5 @@
           death_rate(i) = 0.
         END IF
+
         d_sigmaw(i) = gfl(i)*cstar(i)*dtimesub - death_rate(i)*sigmaw(i)* &
           dtimesub
@@ -798,5 +832,4 @@
       END IF
     END DO
-
 
     ! calcul de la difference de vitesse verticale poche - zone non perturbee
@@ -1006,13 +1039,15 @@
 
           d_deltatw(i, k) = dtimesub/(ph(i,k)-ph(i,k+1))* &
-            (rrd1*omg(i,k)*sigmaw(i)*d_th1(i,k)-rrd2*omg(i,k+1)*(1.-sigmaw( &
-            i))*d_th2(i,k+1)-(1.-alpha_up(i,k))*omgbdth(i,k)-alpha_up(i,k+1)* &
-            omgbdth(i,k+1))*ppi(i, k)
+            (rrd1*omg(i,k)*sigmaw(i)*d_th1(i,k) - &
+             rrd2*omg(i,k+1)*(1.-sigmaw(i))*d_th2(i,k+1)- &
+             (1.-alpha_up(i,k))*omgbdth(i,k)- &
+             alpha_up(i,k+1)*omgbdth(i,k+1))*ppi(i, k)
           ! print*,'d_deltatw=',d_deltatw(i,k)
 
           d_deltaqw(i, k) = dtimesub/(ph(i,k)-ph(i,k+1))* &
-            (rrd1*omg(i,k)*sigmaw(i)*d_q1(i,k)-rrd2*omg(i,k+1)*(1.-sigmaw( &
-            i))*d_q2(i,k+1)-(1.-alpha_up(i,k))*omgbdq(i,k)-alpha_up(i,k+1)* &
-            omgbdq(i,k+1))
+            (rrd1*omg(i,k)*sigmaw(i)*d_q1(i,k)- &
+             rrd2*omg(i,k+1)*(1.-sigmaw(i))*d_q2(i,k+1)- &
+             (1.-alpha_up(i,k))*omgbdq(i,k)- &
+             alpha_up(i,k+1)*omgbdq(i,k+1))
           ! print*,'d_deltaqw=',d_deltaqw(i,k)
 
@@ -1024,26 +1059,19 @@
           ! C
           ! -----------------------------------------------------------------
-          d_te(i, k) = dtimesub*((rre1(i)*omg(i,k)*sigmaw(i)*d_th1(i, &
-            k)-rre2(i)*omg(i,k+1)*(1.-sigmaw(i))*d_th2(i,k+1))/(ph(i,k)-ph(i, &
-            k+1)) &                ! cc nrlmd     $
-                                   ! -sigmaw(i)*(1.-sigmaw(i))*dth(i,k)*dp_deltomg(i,k)
-            -sigmaw(i)*(1.-sigmaw(i))*dth(i,k)*(omg(i,k)-omg(i,k+1))/(ph(i, &
-            k)-ph(i,k+1)) &        ! cc
-            )*ppi(i, k)
-
-          d_qe(i, k) = dtimesub*((rre1(i)*omg(i,k)*sigmaw(i)*d_q1(i, &
-            k)-rre2(i)*omg(i,k+1)*(1.-sigmaw(i))*d_q2(i,k+1))/(ph(i,k)-ph(i, &
-            k+1)) &                ! cc nrlmd     $
-                                   ! -sigmaw(i)*(1.-sigmaw(i))*deltaqw(i,k)*dp_deltomg(i,k)
-            -sigmaw(i)*(1.-sigmaw(i))*deltaqw(i,k)*(omg(i,k)-omg(i, &
-            k+1))/(ph(i,k)-ph(i,k+1)) & ! cc
-            )
-          ! cc nrlmd
+          d_te(i, k) = dtimesub*((rre1(i)*omg(i,k)*sigmaw(i)*d_th1(i,k)- &
+                                  rre2(i)*omg(i,k+1)*(1.-sigmaw(i))*d_th2(i,k+1))/ &
+                                 (ph(i,k)-ph(i,k+1)) &
+                                 -sigmaw(i)*(1.-sigmaw(i))*dth(i,k)*(omg(i,k)-omg(i,k+1))/ &
+                                 (ph(i,k)-ph(i,k+1)) )*ppi(i, k)
+
+          d_qe(i, k) = dtimesub*((rre1(i)*omg(i,k)*sigmaw(i)*d_q1(i,k)- &
+                                  rre2(i)*omg(i,k+1)*(1.-sigmaw(i))*d_q2(i,k+1))/ &
+                                 (ph(i,k)-ph(i,k+1)) &
+                                 -sigmaw(i)*(1.-sigmaw(i))*deltaqw(i,k)*(omg(i,k)-omg(i,k+1))/ &
+                                 (ph(i,k)-ph(i,k+1)) )
         ELSE IF (wk_adv(i) .AND. k==kupper(i)) THEN
-          d_te(i, k) = dtimesub*((rre1(i)*omg(i,k)*sigmaw(i)*d_th1(i, &
-            k)/(ph(i,k)-ph(i,k+1))))*ppi(i, k)
-
-          d_qe(i, k) = dtimesub*((rre1(i)*omg(i,k)*sigmaw(i)*d_q1(i, &
-            k)/(ph(i,k)-ph(i,k+1))))
+          d_te(i, k) = dtimesub*(rre1(i)*omg(i,k)*sigmaw(i)*d_th1(i,k)/(ph(i,k)-ph(i,k+1)))*ppi(i, k)
+
+          d_qe(i, k) = dtimesub*(rre1(i)*omg(i,k)*sigmaw(i)*d_q1(i,k)/(ph(i,k)-ph(i,k+1)))
 
         END IF
@@ -1067,6 +1095,6 @@
           crep(i, k) = crep_sol*(ph(i,kupper(i))-ph(i,k))/ &
             (ph(i,kupper(i))-ph(i,1))
-          crep(i, k) = crep(i, k) + crep_upper*(ph(i,1)-ph(i,k))/(p(i,1)-ph(i &
-            ,kupper(i)))
+          crep(i, k) = crep(i, k) + crep_upper*(ph(i,1)-ph(i,k))/ &
+            (p(i,1)-ph(i,kupper(i)))
 
 
@@ -1091,21 +1119,4 @@
           ! print*,'dtKE= ',dtKE(i,k),' dqKE= ',dqKE(i,k)
 
-!jyg<
-!!
-!!---------------------------------------------------------------
-!! The change of delta_T due to PBL (vertical diffusion plus thermal plumes)
-!! is accounted for by the PBL and the Thermals schemes. It is now set to zero 
-!! within the Wake scheme.
-!!---------------------------------------------------------------
-          dtPBL(i,k) = 0.
-          dqPBL(i,k) = 0.
-! 
-!!          dtPBL(i,k)=wdtPBL(i,k) - udtPBL(i,k)
-!!          dqPBL(i,k)=wdqPBL(i,k) - udqPBL(i,k)
-! 
-!!          dtpbl(i, k) = (wdtpbl(i,k)/sigmaw(i)-udtpbl(i,k)/(1.-sigmaw(i)))
-!!          dqpbl(i, k) = (wdqpbl(i,k)/sigmaw(i)-udqpbl(i,k)/(1.-sigmaw(i)))
-          ! print*,'dtPBL= ',dtPBL(i,k),' dqPBL= ',dqPBL(i,k)
-!>jyg
 !
 
@@ -1145,17 +1156,14 @@
 
           IF (dtimesub*tgw(i,k)<1.E-10) THEN
-            d_deltatw(i, k) = dtimesub*(ff(i)+dtke(i,k)+dtpbl(i,k) & ! cc
-                                                                     ! $
-                                                                     ! -spread(i,k)*deltatw(i,k)
-              -entr(i,k)*deltatw(i,k)/sigmaw(i)-(death_rate(i)*sigmaw( &
-              i)+detr(i,k))*deltatw(i,k)/(1.-sigmaw(i)) & ! cc
-              -tgw(i,k)*deltatw(i,k))
+            d_deltatw(i, k) = dtimesub*(ff(i)+dtke(i,k) - & 
+               entr(i,k)*deltatw(i,k)/sigmaw(i) - &
+               (death_rate(i)*sigmaw(i)+detr(i,k))*deltatw(i,k)/(1.-sigmaw(i)) - & ! cc
+               tgw(i,k)*deltatw(i,k) )
           ELSE
-            d_deltatw(i, k) = 1/tgw(i, k)*(1-exp(-dtimesub*tgw(i, &
-              k)))*(ff(i)+dtke(i,k)+dtpbl(i,k) & ! cc     $
-                                                 ! -spread(i,k)*deltatw(i,k)
-              -entr(i,k)*deltatw(i,k)/sigmaw(i)-(death_rate(i)*sigmaw( &
-              i)+detr(i,k))*deltatw(i,k)/(1.-sigmaw(i)) & ! cc
-              -tgw(i,k)*deltatw(i,k))
+            d_deltatw(i, k) = 1/tgw(i, k)*(1-exp(-dtimesub*tgw(i,k)))* &
+               (ff(i)+dtke(i,k) - &
+                entr(i,k)*deltatw(i,k)/sigmaw(i) - &
+                (death_rate(i)*sigmaw(i)+detr(i,k))*deltatw(i,k)/(1.-sigmaw(i)) - &
+                tgw(i,k)*deltatw(i,k) )
           END IF
 
@@ -1164,8 +1172,7 @@
           gg(i) = d_deltaqw(i, k)/dtimesub
 
-          d_deltaqw(i, k) = dtimesub*(gg(i)+dqke(i,k)+dqpbl(i,k) & ! cc     $
-                                                                   ! -spread(i,k)*deltaqw(i,k))
-            -entr(i,k)*deltaqw(i,k)/sigmaw(i)-(death_rate(i)*sigmaw(i)+detr( &
-            i,k))*deltaqw(i,k)/(1.-sigmaw(i)))
+          d_deltaqw(i, k) = dtimesub*(gg(i)+dqke(i,k) - & 
+            entr(i,k)*deltaqw(i,k)/sigmaw(i) - &
+            (death_rate(i)*sigmaw(i)+detr(i,k))*deltaqw(i,k)/(1.-sigmaw(i)))
           ! cc
 
@@ -1239,4 +1246,7 @@
       IF (wk_adv(i)) THEN
         sigmaw(i) = sigmaw(i) + d_sigmaw(i)
+!jyg<
+        d_sigmaw2(i) = d_sigmaw2(i) + d_sigmaw(i)
+!>jyg
       END IF
     END DO
@@ -1258,6 +1268,6 @@
         IF (wk_adv(i) .AND. ptop_provis(i)==ph(i,1) .AND. &
             dth(i,k)>-delta_t_min .AND. dth(i,k-1)<-delta_t_min) THEN
-          ptop_provis(i) = ((dth(i,k)+delta_t_min)*p(i,k-1)-(dth(i, &
-            k-1)+delta_t_min)*p(i,k))/(dth(i,k)-dth(i,k-1))
+          ptop_provis(i) = ((dth(i,k)+delta_t_min)*p(i,k-1) - &
+                            (dth(i,k-1)+delta_t_min)*p(i,k))/(dth(i,k)-dth(i,k-1))
         END IF
       END DO
@@ -1331,6 +1341,6 @@
         IF (wk_adv(i) .AND. k<=ktop(i) .AND. ptop_new(i)==ptop(i) .AND. &
             dth(i,k)>-delta_t_min .AND. dth(i,k-1)<-delta_t_min) THEN
-          ptop_new(i) = ((dth(i,k)+delta_t_min)*p(i,k-1)-(dth(i, &
-            k-1)+delta_t_min)*p(i,k))/(dth(i,k)-dth(i,k-1))
+          ptop_new(i) = ((dth(i,k)+delta_t_min)*p(i,k-1) - &
+                         (dth(i,k-1)+delta_t_min)*p(i,k))/(dth(i,k)-dth(i,k-1))
         END IF
       END DO
@@ -1359,4 +1369,6 @@
           deltatw(i, k) = 0.
           deltaqw(i, k) = 0.
+          d_deltatw2(i,k) = -deltatw0(i,k)
+          d_deltaqw2(i,k) = -deltaqw0(i,k)
         END IF
       END DO
@@ -1449,6 +1461,6 @@
         av_dqdwn(i) = sum_dqdwn(i)/hw0(i)
 
-        wape(i) = -rg*hw0(i)*(av_dth(i)+epsim1*(av_thu(i)*av_dq(i)+av_dth(i)* &
-          av_qu(i)+av_dth(i)*av_dq(i)))/av_thvu(i)
+        wape(i) = -rg*hw0(i)*(av_dth(i)+epsim1*(av_thu(i)*av_dq(i) + &
+                              av_dth(i)*av_qu(i)+av_dth(i)*av_dq(i)))/av_thvu(i)
       END IF
     END DO
@@ -1463,4 +1475,6 @@
             deltaqw(i, k) = 0.
             dth(i, k) = 0.
+            d_deltatw2(i,k) = -deltatw0(i,k)
+            d_deltaqw2(i,k) = -deltaqw0(i,k)
           END IF
         END IF
@@ -1474,5 +1488,10 @@
           cstar(i) = 0.
           hw(i) = hwmin
-          sigmaw(i) = max(sigmad, sigd_con(i))
+!jyg<
+!!          sigmaw(i) = max(sigmad, sigd_con(i))
+          sigmaw_targ = max(sigmad, sigd_con(i))
+          d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+          sigmaw(i) = sigmaw_targ
+!>jyg
           fip(i) = 0.
           gwake(i) = .FALSE.
@@ -1486,23 +1505,4 @@
   END DO ! end sub-timestep loop
 
-  ! -----------------------------------------------------------------
-  ! Get back to tendencies per second
-
-  DO k = 1, klev
-    DO i = 1, klon
-
-      ! cc nrlmd        IF ( wk_adv(i) .AND. k .LE. kupper(i)) THEN
-      IF (ok_qx_qw(i) .AND. k<=kupper(i)) THEN
-        ! cc
-        dtls(i, k) = dtls(i, k)/dtime
-        dqls(i, k) = dqls(i, k)/dtime
-        d_deltatw2(i, k) = d_deltatw2(i, k)/dtime
-        d_deltaqw2(i, k) = d_deltaqw2(i, k)/dtime
-        d_deltat_gw(i, k) = d_deltat_gw(i, k)/dtime
-        ! c      print*,'k,dqls,omg,entr,detr',k,dqls(i,k),omg(i,k),entr(i,k)
-        ! c     $         ,death_rate(i)*sigmaw(i)
-      END IF
-    END DO
-  END DO
 
 
@@ -1632,8 +1632,10 @@
       av_dqdwn(i) = sum_dqdwn(i)/hw0(i)
 
-      wape2(i) = -rg*hw0(i)*(av_dth(i)+epsim1*(av_thu(i)*av_dq(i)+av_dth(i)* &
-        av_qu(i)+av_dth(i)*av_dq(i)))/av_thvu(i)
+      wape2(i) = -rg*hw0(i)*(av_dth(i)+epsim1*(av_thu(i)*av_dq(i) + &
+                             av_dth(i)*av_qu(i)+av_dth(i)*av_dq(i)))/av_thvu(i)
     END IF
   END DO
+
+
 
   ! Prognostic variable update
@@ -1650,4 +1652,6 @@
         deltaqw(i, k) = 0.
         dth(i, k) = 0.
+        d_deltatw2(i,k) = -deltatw0(i,k)
+        d_deltaqw2(i,k) = -deltaqw0(i,k)
       END IF
     END DO
@@ -1663,5 +1667,10 @@
         cstar2(i) = 0.
         hw(i) = hwmin
-        sigmaw(i) = amax1(sigmad, sigd_con(i))
+!jyg<
+!!      sigmaw(i) = amax1(sigmad, sigd_con(i))
+      sigmaw_targ = max(sigmad, sigd_con(i))
+      d_sigmaw2(i) = d_sigmaw2(i) + sigmaw_targ - sigmaw(i)
+      sigmaw(i) = sigmaw_targ
+!>jyg
         fip(i) = 0.
         gwake(i) = .FALSE.
@@ -1726,4 +1735,6 @@
         deltatw(i, k) = 0.
         deltaqw(i, k) = 0.
+        d_deltatw2(i,k) = -deltatw0(i,k)
+        d_deltaqw2(i,k) = -deltaqw0(i,k)
       END IF
     END DO
@@ -1734,4 +1745,5 @@
     IF (((wape(i)>=wape2(i)) .AND. (wape2(i)<=1.0)) .OR. (ktopw(i)<=2) .OR. &
         .NOT. ok_qx_qw(i)) THEN
+      ktopw(i) = 0
       wape(i) = 0.
       cstar(i) = 0.
@@ -1749,4 +1761,31 @@
     ! c     $          wape(i),wape2(i),ktopw(i),OK_qx_qw(i)
   END DO
+
+  ! -----------------------------------------------------------------
+  ! Get back to tendencies per second
+
+  DO k = 1, klev
+    DO i = 1, klon
+
+      ! cc nrlmd        IF ( wk_adv(i) .AND. k .LE. kupper(i)) THEN
+      IF (ok_qx_qw(i) .AND. k<=kupper(i)) THEN
+        ! cc
+        dtls(i, k) = dtls(i, k)/dtime
+        dqls(i, k) = dqls(i, k)/dtime
+        d_deltatw2(i, k) = d_deltatw2(i, k)/dtime
+        d_deltaqw2(i, k) = d_deltaqw2(i, k)/dtime
+        d_deltat_gw(i, k) = d_deltat_gw(i, k)/dtime
+        ! c      print*,'k,dqls,omg,entr,detr',k,dqls(i,k),omg(i,k),entr(i,k)
+        ! c     $         ,death_rate(i)*sigmaw(i)
+      END IF
+    END DO
+  END DO
+!jyg<
+  DO i = 1, klon
+    d_sigmaw2(i) = d_sigmaw2(i)/dtime
+    d_wdens2(i) = d_wdens2(i)/dtime
+  ENDDO
+!>jyg
+
 
 
@@ -1792,6 +1831,6 @@
       IF (wk_adv(i)) THEN
         x = qe(i, k) + (zeta(i,k)-sigmaw(i))*deltaqw(i, k) + d_qe(i, k) + &
-          (zeta(i,k)-sigmaw(i))*d_deltaqw(i, k) - d_sigmaw(i)*(deltaqw(i,k)+ &
-          d_deltaqw(i,k))
+          (zeta(i,k)-sigmaw(i))*d_deltaqw(i, k) - d_sigmaw(i) * &
+          (deltaqw(i,k)+d_deltaqw(i,k))
         a = -d_sigmaw(i)*d_deltaqw(i, k)
         b = d_qe(i, k) + (zeta(i,k)-sigmaw(i))*d_deltaqw(i, k) - &
@@ -1807,12 +1846,12 @@
           ELSE
             IF (a>0.) THEN
-              alpha1(i) = 0.9*min((2.*c)/(-b+sqrt(discrim)), (-b+sqrt(discrim &
-                ))/(2.*a))
+              alpha1(i) = 0.9*min( (2.*c)/(-b+sqrt(discrim)),  &
+                                   (-b+sqrt(discrim))/(2.*a) )
             ELSE IF (a==0.) THEN
               alpha1(i) = 0.9*(-c/b)
             ELSE
               ! print*,'a,b,c discrim',a,b,c discrim
-              alpha1(i) = 0.9*max((2.*c)/(-b+sqrt(discrim)), (-b+sqrt(discrim &
-                ))/(2.*a))
+              alpha1(i) = 0.9*max( (2.*c)/(-b+sqrt(discrim)),  &
+                                   (-b+sqrt(discrim))/(2.*a))
             END IF
           END IF
@@ -1827,2 +1866,4 @@
 
 
+
+
